JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
FlacAudioFormat Class Reference
juce_audio_formats » codecs

Reads and writes the lossless-compression FLAC audio format. More...

`#include <juce_FlacAudioFormat.h>`

Inheritance diagram for FlacAudioFormat:

## Public Member Functions
| FlacAudioFormat ()
| ~FlacAudioFormat () override
Array< int > | getPossibleSampleRates () override
| Returns a set of sample rates that the format can read and write.
Array< int > | getPossibleBitDepths () override
| Returns a set of bit depths that the format can read and write.
bool | canDoStereo () override
| Returns true if the format can do 2-channel audio.
bool | canDoMono () override
| Returns true if the format can do 1-channel audio.
bool | isCompressed () override
| Returns true if the format uses compressed data.
StringArray | getQualityOptions () override
| Returns a list of different qualities that can be used when writing.
AudioFormatReader * | createReaderFor (InputStream *sourceStream, bool deleteStreamIfOpeningFails) override
| Tries to create an object that can read from a stream containing audio data in this format.
AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, unsigned int numberOfChannels, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex) override
| Tries to create an object that can write to a stream with this audio format.
virtual AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, unsigned int numberOfChannels, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex)=0
| Tries to create an object that can write to a stream with this audio format.
virtual AudioFormatWriter * | createWriterFor (OutputStream *streamToWriteTo, double sampleRateToUse, const AudioChannelSet &channelLayout, int bitsPerSample, const StringPairArray &metadataValues, int qualityOptionIndex)
| Tries to create an object that can write to a stream with this audio format.
Public Member Functions inherited from AudioFormat
virtual | ~AudioFormat ()
| Destructor.
const String & | getFormatName () const
| Returns the name of this format.
virtual StringArray | getFileExtensions () const
| Returns all the file extensions that might apply to a file of this format.
virtual bool | canHandleFile (const File &fileToTest)
| Returns true if this the given file can be read by this format.
virtual bool | isChannelLayoutSupported (const AudioChannelSet &channelSet)
| Returns true if the channel layout is supported by this format.
virtual MemoryMappedAudioFormatReader * | createMemoryMappedReader (const File &file)
| Attempts to create a MemoryMappedAudioFormatReader, if possible for this format.
virtual MemoryMappedAudioFormatReader * | createMemoryMappedReader (FileInputStream *fin)

## Additional Inherited Members
Protected Member Functions inherited from AudioFormat
| AudioFormat (String formatName, StringArray fileExtensions)
| Creates an AudioFormat object.
| AudioFormat (StringRef formatName, StringRef fileExtensions)
| Creates an AudioFormat object.

## Detailed Description

Reads and writes the lossless-compression FLAC audio format.

To compile this, you'll need to set the JUCE_USE_FLAC flag.

See also
  AudioFormat

## Constructor & Destructor Documentation

## ◆ FlacAudioFormat()

FlacAudioFormat::FlacAudioFormat | ( |  | ) |

## ◆ ~FlacAudioFormat()

FlacAudioFormat::~FlacAudioFormat | ( |  | ) |
| override

## Member Function Documentation

## ◆ getPossibleSampleRates()

Array< int > FlacAudioFormat::getPossibleSampleRates | ( |  | ) |
| override virtual

Returns a set of sample rates that the format can read and write.

Implements AudioFormat.

## ◆ getPossibleBitDepths()

Array< int > FlacAudioFormat::getPossibleBitDepths | ( |  | ) |
| override virtual

Returns a set of bit depths that the format can read and write.

Implements AudioFormat.

## ◆ canDoStereo()

bool FlacAudioFormat::canDoStereo | ( |  | ) |
| override virtual

Returns true if the format can do 2-channel audio.

Implements AudioFormat.

## ◆ canDoMono()

bool FlacAudioFormat::canDoMono | ( |  | ) |
| override virtual

Returns true if the format can do 1-channel audio.

Implements AudioFormat.

## ◆ isCompressed()

bool FlacAudioFormat::isCompressed | ( |  | ) |
| override virtual

Returns true if the format uses compressed data.

Reimplemented from AudioFormat.

## ◆ getQualityOptions()

StringArray FlacAudioFormat::getQualityOptions | ( |  | ) |
| override virtual

Returns a list of different qualities that can be used when writing.

Non-compressed formats will just return an empty array, but for something like Ogg-Vorbis or MP3, it might return a list of bit-rates, etc.

When calling createWriterFor(), an index from this array is passed in to tell the format which option is required.

Reimplemented from AudioFormat.

## ◆ createReaderFor()

AudioFormatReader * FlacAudioFormat::createReaderFor | ( | InputStream * | sourceStream,
|  | bool | deleteStreamIfOpeningFails )
| override virtual

Tries to create an object that can read from a stream containing audio data in this format.

The reader object that is returned can be used to read from the stream, and should then be deleted by the caller.

Parameters

  sourceStream | the stream to read from - the AudioFormatReader object that is returned will delete this stream when it no longer needs it.
  deleteStreamIfOpeningFails | if no reader can be created, this determines whether this method should delete the stream object that was passed-in. (If a valid reader is returned, it will always be in charge of deleting the stream, so this parameter is ignored)

See also
  AudioFormatReader

Implements AudioFormat.

## ◆ createWriterFor() [1/3]

AudioFormatWriter * FlacAudioFormat::createWriterFor | ( | OutputStream * | streamToWriteTo,
|  | double | sampleRateToUse,
|  | unsigned int | numberOfChannels,
|  | int | bitsPerSample,
|  | const StringPairArray & | metadataValues,
|  | int | qualityOptionIndex )
| override virtual

Tries to create an object that can write to a stream with this audio format.

The writer object that is returned can be used to write to the stream, and should then be deleted by the caller.

If the stream can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | the stream that the data will go to - this will be deleted by the AudioFormatWriter object when it's no longer needed. If no AudioFormatWriter can be created by this method, the stream will NOT be deleted, so that the caller can re-use it to try to open a different format, etc
  sampleRateToUse | the sample rate for the file, which must be one of the ones returned by getPossibleSampleRates()
  numberOfChannels | the number of channels
  bitsPerSample | the bits per sample to use - this must be one of the values returned by getPossibleBitDepths()
  metadataValues | a set of metadata values that the writer should try to write to the stream. Exactly what these are depends on the format, and the subclass doesn't actually have to do anything with them if it doesn't want to. Have a look at the specific format implementation classes to see possible values that can be used
  qualityOptionIndex | the index of one of compression qualities returned by the getQualityOptions() method. If there aren't any quality options for this format, just pass 0 in this parameter, as it'll be ignored

See also
  AudioFormatWriter

Implements AudioFormat.

## ◆ createWriterFor() [2/3]

virtual AudioFormatWriter * AudioFormat::createWriterFor | ( | OutputStream * | streamToWriteTo,
|  | double | sampleRateToUse,
|  | unsigned int | numberOfChannels,
|  | int | bitsPerSample,
|  | const StringPairArray & | metadataValues,
|  | int | qualityOptionIndex )
| virtual

Tries to create an object that can write to a stream with this audio format.

The writer object that is returned can be used to write to the stream, and should then be deleted by the caller.

If the stream can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | the stream that the data will go to - this will be deleted by the AudioFormatWriter object when it's no longer needed. If no AudioFormatWriter can be created by this method, the stream will NOT be deleted, so that the caller can re-use it to try to open a different format, etc
  sampleRateToUse | the sample rate for the file, which must be one of the ones returned by getPossibleSampleRates()
  numberOfChannels | the number of channels
  bitsPerSample | the bits per sample to use - this must be one of the values returned by getPossibleBitDepths()
  metadataValues | a set of metadata values that the writer should try to write to the stream. Exactly what these are depends on the format, and the subclass doesn't actually have to do anything with them if it doesn't want to. Have a look at the specific format implementation classes to see possible values that can be used
  qualityOptionIndex | the index of one of compression qualities returned by the getQualityOptions() method. If there aren't any quality options for this format, just pass 0 in this parameter, as it'll be ignored

See also
  AudioFormatWriter

Implements AudioFormat.

## ◆ createWriterFor() [3/3]

virtual AudioFormatWriter * AudioFormat::createWriterFor | ( | OutputStream * | streamToWriteTo,
|  | double | sampleRateToUse,
|  | const AudioChannelSet & | channelLayout,
|  | int | bitsPerSample,
|  | const StringPairArray & | metadataValues,
|  | int | qualityOptionIndex )
| virtual

Tries to create an object that can write to a stream with this audio format.

The writer object that is returned can be used to write to the stream, and should then be deleted by the caller.

If the stream can't be created for some reason (e.g. the parameters passed in here aren't suitable), this will return nullptr.

Parameters

  streamToWriteTo | the stream that the data will go to - this will be deleted by the AudioFormatWriter object when it's no longer needed. If no AudioFormatWriter can be created by this method, the stream will NOT be deleted, so that the caller can re-use it to try to open a different format, etc
  sampleRateToUse | the sample rate for the file, which must be one of the ones returned by getPossibleSampleRates()
  channelLayout | the channel layout for the file. Use isChannelLayoutSupported to check if the writer supports this layout.
  bitsPerSample | the bits per sample to use - this must be one of the values returned by getPossibleBitDepths()
  metadataValues | a set of metadata values that the writer should try to write to the stream. Exactly what these are depends on the format, and the subclass doesn't actually have to do anything with them if it doesn't want to. Have a look at the specific format implementation classes to see possible values that can be used
  qualityOptionIndex | the index of one of compression qualities returned by the getQualityOptions() method. If there aren't any quality options for this format, just pass 0 in this parameter, as it'll be ignored

See also
  AudioFormatWriter

Reimplemented from AudioFormat.

The documentation for this class was generated from the following file:

- juce_FlacAudioFormat.h